scala.tools.nsc.transform.patmat.MatchTreeMaking

# TreeMakers

###
Related Doc: package MatchTreeMaking

#### trait TreeMakers extends TypedSubstitution with CodegenCore

Source
  MatchTreeMaking.scala

Linear Supertypes
MatchTreeMaking.CodegenCore, MatchTreeMaking.TypedSubstitution, MatchTreeMaking.MatchMonadInterface, AnyRef, Any
Known Subclasses
CommonSubconditionElimination, MatchAnalyzer, MatchApproximator, MatchOptimizer, MatchTranslator, OptimizingMatchTranslator, PureMatchTranslator, SwitchEmission
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TreeMakers
2. CodegenCore
3. TypedSubstitution
4. MatchMonadInterface
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Type Members

1. #### trait AbsCodegen extends AnyRef

   Definition Classes
     CodegenCore

2. #### case class AlternativesTreeMaker (prevBinder: Global.Symbol, altss: List[List[TreeMaker]], pos: Global.Position) extends TreeMaker with NoNewBinders with Product with Serializable

3. #### case class BodyTreeMaker (body: Global.Tree, matchPt: Global.Type) extends TreeMaker with NoNewBinders with Product with Serializable

4. #### trait Casegen extends AbsCodegen

   Definition Classes
     CodegenCore

5. #### abstract class CommonCodegen extends AbsCodegen

   Definition Classes
     CodegenCore

6. #### sealed abstract class CondTreeMaker extends FunTreeMaker

7. #### case class EqualityTestTreeMaker (prevBinder: Global.Symbol, patTree: Global.Tree, pos: Global.Position) extends CondTreeMaker with Product with Serializable

8. #### case class ExtractorTreeMaker (extractor: Global.Tree, extraCond: Option[Global.Tree], nextBinder: Global.Symbol)(subPatBinders: List[Global.Symbol], subPatRefs: List[Global.Tree], potentiallyMutableBinders: Set[Global.Symbol], extractorReturnsBoolean: Boolean, checkedLength: Option[Int], prevBinder: Global.Symbol, ignoredSubPatBinders: Set[Global.Symbol]) extends FunTreeMaker with PreserveSubPatBinders with Product with Serializable

   Make a TreeMaker that will result in an extractor call specified by `extractor` the next TreeMaker (here, we don't know which it'll be) is chained after this one by flatMap'ing a function with binder `nextBinder` over our extractor's result the function's body is determined by the next TreeMaker (furthermore, the interpretation of `flatMap` depends on the codegen instance we're using).

   Make a TreeMaker that will result in an extractor call specified by `extractor` the next TreeMaker (here, we don't know which it'll be) is chained after this one by flatMap'ing a function with binder `nextBinder` over our extractor's result the function's body is determined by the next TreeMaker (furthermore, the interpretation of `flatMap` depends on the codegen instance we're using).

   The values for the subpatterns, as computed by the extractor call in `extractor`, are stored in local variables that re-use the symbols in `subPatBinders`. This makes extractor patterns more debuggable (SI-5739).

9. #### sealed abstract class FunTreeMaker extends TreeMaker

10. #### case class GuardTreeMaker (guardTree: Global.Tree) extends TreeMaker with NoNewBinders with Product with Serializable

11. #### sealed trait NoNewBinders extends TreeMaker

12. #### sealed trait PreserveSubPatBinders extends TreeMaker

13. #### case class ProductExtractorTreeMaker (prevBinder: Global.Symbol, extraCond: Option[Global.Tree])(subPatBinders: List[Global.Symbol], subPatRefs: List[Global.Tree], mutableBinders: List[Global.Symbol], binderKnownNonNull: Boolean, ignoredSubPatBinders: Set[Global.Symbol]) extends FunTreeMaker with PreserveSubPatBinders with Product with Serializable

    An optimized version of ExtractorTreeMaker for Products.

    An optimized version of ExtractorTreeMaker for Products. For now, this is hard-coded to case classes, and we simply extract the case class fields.

    The values for the subpatterns, as specified by the case class fields at the time of extraction, are stored in local variables that re-use the symbols in `subPatBinders`. This makes extractor patterns more debuggable (SI-5739) as well as avoiding mutation after the pattern has been matched (SI-5158, SI-6070)

    TODO: make this user-definable as follows When a companion object defines a method `def unapply_1(x: T): U_1`, but no `def unapply` or `def unapplySeq`, the extractor is considered to match any non-null value of type T the pattern is expected to have as many sub-patterns as there are `def unapply_I(x: T): U_I` methods, and the type of the I'th sub-pattern is `U_I`. The same exception for Seq patterns applies: if the last extractor is of type `Seq[U_N]`, the pattern must have at least N arguments (exactly N if the last argument is annotated with `: _*`). The arguments starting at N (and beyond) are taken from the sequence returned by apply_N, and it is checked that that sequence has enough elements to provide values for all expected sub-patterns.

    For a case class C, the implementation is assumed to be `def unapply_I(x: C) = x._I`, and the extractor call is inlined under that assumption.

14. #### case class SubstOnlyTreeMaker (prevBinder: Global.Symbol, nextBinder: Global.Symbol) extends TreeMaker with Product with Serializable

15. #### class Substitution extends AnyRef

    Definition Classes
      TypedSubstitution

16. #### abstract class TreeMaker extends AnyRef

17. #### case class TrivialTreeMaker (tree: Global.Tree) extends TreeMaker with NoNewBinders with Product with Serializable

18. #### case class TypeTestTreeMaker (prevBinder: Global.Symbol, testedBinder: Global.Symbol, expectedTp: Global.Type, nextBinderTp: Global.Type)(pos: Global.Position, extractorArgTypeTest: Boolean = false) extends CondTreeMaker with Product with Serializable

    implements the run-time aspects of (§8.2) (typedPattern has already done the necessary type transformations)

    implements the run-time aspects of (§8.2) (typedPattern has already done the necessary type transformations)

    Type patterns consist of types, type variables, and wildcards. A type pattern T is of one of the following forms:

    - A reference to a class C, p.C, or T#C. This type pattern matches any non-null instance of the given class. Note that the prefix of the class, if it is given, is relevant for determining class instances. For instance, the pattern p.C matches only instances of classes C which were created with the path p as prefix. The bottom types scala.Nothing and scala.Null cannot be used as type patterns, because they would match nothing in any case.
    - A singleton type p.type. This type pattern matches only the value denoted by the path p (that is, a pattern match involved a comparison of the matched value with p using method eq in class AnyRef). // TODO: the actual pattern matcher uses ==, so that's what I'm using for now // https://issues.scala-lang.org/browse/SI-4577 "pattern matcher, still disappointing us at equality time"
    - A compound type pattern T1 with ... with Tn where each Ti is a type pat- tern. This type pattern matches all values that are matched by each of the type patterns Ti.
    - A parameterized type pattern T[a1,...,an], where the ai are type variable patterns or wildcards _. This type pattern matches all values which match T for some arbitrary instantiation of the type variables and wildcards. The bounds or alias type of these type variable are determined as described in (§8.3).
    - A parameterized type pattern scala.Array[T1], where T1 is a type pattern. // TODO This type pattern matches any non-null instance of type scala.Array[U1], where U1 is a type matched by T1.

### Abstract Value Members

1. #### abstract def analyzeCases(prevBinder: Global.Symbol, cases: List[List[TreeMaker]], pt: Global.Type, suppression: Suppression): Unit

2. #### abstract def codegen: AbsCodegen

   Definition Classes
     CodegenCore

3. #### abstract def optimizeCases(prevBinder: Global.Symbol, cases: List[List[TreeMaker]], pt: Global.Type): (List[List[TreeMaker]], List[Global.Tree])

4. #### abstract val typer: (analyzer)#Typer

   Definition Classes
     MatchMonadInterface

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TreeMakers to any2stringadd[TreeMakers] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (TreeMakers, B)

   Implicit information
     This member is added by an implicit conversion from TreeMakers to ArrowAssoc[TreeMakers] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object EmptySubstitution extends Substitution

   Definition Classes
     TypedSubstitution

7. #### object IrrefutableExtractorTreeMaker

8. #### object Substitution

   Definition Classes
     TypedSubstitution

9. #### object TypeTestTreeMaker extends Serializable

10. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### def combineCases(scrut: Global.Tree, scrutSym: Global.Symbol, casesRaw: List[List[TreeMaker]], pt: Global.Type, owner: Global.Symbol, matchFailGenOverride: Option[(Global.Tree) ⇒ Global.Tree]): Global.Tree

13. #### def combineCasesNoSubstOnly(scrut: Global.Tree, scrutSym: Global.Symbol, casesNoSubstOnly: List[List[TreeMaker]], pt: Global.Type, owner: Global.Symbol, matchFailGenOverride: Option[(Global.Tree) ⇒ Global.Tree]): Global.Tree

14. #### def combineExtractors(treeMakers: List[TreeMaker])(casegen: Casegen): Global.Tree

15. #### val debugInfoEmitVars: Boolean

    Attributes
      protected

16. #### def emitSwitch(scrut: Global.Tree, scrutSym: Global.Symbol, cases: List[List[TreeMaker]], pt: Global.Type, matchFailGenOverride: Option[(Global.Tree) ⇒ Global.Tree], unchecked: Boolean): Option[Global.Tree]

17. #### def emitTypeSwitch(bindersAndCases: List[(Global.Symbol, List[TreeMaker])], pt: Global.Type): Option[List[Global.CaseDef]]

18. #### def ensuring(cond: (TreeMakers) ⇒ Boolean, msg: ⇒ Any): TreeMakers

    Implicit information
      This member is added by an implicit conversion from TreeMakers to Ensuring[TreeMakers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: (TreeMakers) ⇒ Boolean): TreeMakers

    Implicit information
      This member is added by an implicit conversion from TreeMakers to Ensuring[TreeMakers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean, msg: ⇒ Any): TreeMakers

    Implicit information
      This member is added by an implicit conversion from TreeMakers to Ensuring[TreeMakers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean): TreeMakers

    Implicit information
      This member is added by an implicit conversion from TreeMakers to Ensuring[TreeMakers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

24. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

25. #### def fixerUpper(origOwner: Global.Symbol, pos: Global.Position): Global.Traverser

    Attributes
      protected

26. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from TreeMakers to StringFormat[TreeMakers] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

27. #### def freshName(prefix: String): Global.TermName

    Definition Classes
      CodegenCore

28. #### def freshSym(pos: Global.Position, tp: Global.Type = NoType, prefix: String = "x"): Global.TermSymbol

    Definition Classes
      CodegenCore

29. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

30. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

31. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

32. #### val matchOwner: Global.Symbol

    Definition Classes
      MatchMonadInterface

33. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

34. #### def newSynthCaseLabel(name: String): Global.MethodSymbol

    Definition Classes
      CodegenCore

35. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

36. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

37. #### def propagateSubstitution(treeMakers: List[TreeMaker], initial: Substitution): List[TreeMaker]

38. #### def pureType(tp: Global.Type): Global.Type

    Definition Classes
      MatchMonadInterface

39. #### def removeSubstOnly(makers: List[TreeMaker]): collection.immutable.List[TreeMaker]

40. #### def reportMissingCases(pos: Global.Position, counterExamples: List[String]): Unit

    Definition Classes
      MatchMonadInterface

41. #### def reportUnreachable(pos: Global.Position): Unit

    Definition Classes
      MatchMonadInterface

42. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

43. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

44. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

47. #### def →[B](y: B): (TreeMakers, B)

    Implicit information
      This member is added by an implicit conversion from TreeMakers to ArrowAssoc[TreeMakers] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from MatchTreeMaking.CodegenCore

### Inherited from MatchTreeMaking.TypedSubstitution

### Inherited from MatchTreeMaking.MatchMonadInterface

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TreeMakers to any2stringadd[TreeMakers]

### Inherited by implicit conversion StringFormat from TreeMakers to StringFormat[TreeMakers]

### Inherited by implicit conversion Ensuring from TreeMakers to Ensuring[TreeMakers]

### Inherited by implicit conversion ArrowAssoc from TreeMakers to ArrowAssoc[TreeMakers]

### Ungrouped